/*
 * File         : Application.java
 * Author       : Tomasz Stachowiak
 * Created      : Wed Jun 18 17:53:03 1997
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

import java.sql.*;

class Application {

  String name;
  String type;
  String platform;

  NCSdatabase db;

  AppData data;

  public Application(NCSdatabase database, String n) {

    db = database;

    name = n;
    type = "unknown";
    platform = "all";
  }

  public Application(NCSdatabase database) {

    db = database;

  }

  public AppData getAppData() {

    return data;

  }

  public void add2db() {

    String sql = "INSERT INTO application VALUES ('"
      +name+"','"+type+"','"+platform+"')";

    db.updateSQL(sql);

  }


  public boolean isInDb() {
    
    String sql = "SELECT * FROM application WHERE name='" 
                 +name+"'";
 
    try {
      ResultSet rs = db.querySQL(sql);

      if(!rs.next())
	return false;
      else
	return true;

    } catch (SQLException e) {
      
      System.out.println("Application: " + e);
    }

    return true;            
  }

  public void start(Session ses) {

    if(!isInDb())
      add2db();

    String sql = "INSERT INTO includes VALUES ("
      +ses.getID()+",'"+name+"')";

    db.updateSQL(sql);
  }

  public void retrieve(ResultSet rs) throws SQLException {

    name = rs.getString("name");
    type = rs.getString("type");
    platform = rs.getString("platform");

  }


  public void retrieveData(Session ses) {

    String sql = "SELECT * FROM data WHERE ses_id = "+ses.getID()
      +" app_name = " + name;

    try {
      
      ResultSet rs = db.querySQL(sql);

      if(rs.next()) {
	
	data = new AppData(db);
	data.retrieve(rs);
      }
    } catch (SQLException e) {

      System.out.println("Application: " + e);

    }
	
  }


  public String toString() {

    return name;
  }
}
